STOFFSpreadsheetListener Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
STOFFSpreadsheetListener Class Referencefinal

This class contents the main functions needed to create a spreadsheet processing Document. More...

`#include <STOFFSpreadsheetListener.hxx>`

Inheritance diagram for STOFFSpreadsheetListener:

## Public Member Functions
| STOFFSpreadsheetListener (STOFFListManagerPtr &listManager, std::vector< STOFFPageSpan > const &pageList, librevenge::RVNGSpreadsheetInterface *documentInterface)
| constructor More...
| ~STOFFSpreadsheetListener () final
| destructor More...
Type | getType () const final
| returns the listener type More...
void | setDocumentLanguage (std::string locale) final
| sets the document language More...
void | setDocumentMetaData (const librevenge::RVNGPropertyList &list) final
| sets the document meta data More...
void | startDocument () final
| starts the document More...
void | endDocument (bool sendDelayedSubDoc=true) final
| ends the document More...
bool | isDocumentStarted () const final
| returns true if a document is opened More...
void | handleSubDocument (STOFFSubDocumentPtr subDocument, libstoff::SubDocumentType subDocumentType) final
| function called to add a subdocument More...
bool | isSubDocumentOpened (libstoff::SubDocumentType &subdocType) const final
| returns try if a subdocument is open More...
bool | openFrame (STOFFFrameStyle const &frame, STOFFGraphicStyle const &style=STOFFGraphicStyle()) final
| tries to open a frame More...
void | closeFrame () final
| tries to close a frame More...
bool | openGroup (STOFFFrameStyle const &frame) final
| open a group (not implemented) More...
void | closeGroup () final
| close a group (not implemented) More...
bool | canWriteText () const final
| returns true if we can add text data More...
bool | isPageSpanOpened () const final
| returns true if a page is opened More...
STOFFPageSpan const & | getPageSpan () final
| returns the current page span More...
bool | openHeader (librevenge::RVNGPropertyList const &extras) final
| open a header (interaction with STOFFPageSpan which fills the parameters for openHeader) More...
bool | openFooter (librevenge::RVNGPropertyList const &extras) final
| open a footer (interaction with STOFFPageSpan which fills the parameters for openFooter) More...
bool | closeHeader () final
| close a header More...
bool | closeFooter () final
| close a footer More...
bool | insertHeaderRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which) final
| insert a header More...
bool | insertFooterRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which) final
| insert a footer More...
bool | isHeaderFooterOpened () const final
| returns true if the header/footer is open More...
void | openSheet (std::vector< float > const &colWidth, librevenge::RVNGUnit unit, std::vector< int > const &repeatColWidthNumber=std::vector< int >(), librevenge::RVNGString const &name="")
| open a sheet More...
void | closeSheet ()
| closes this sheet More...
void | openSheetRow (float h, librevenge::RVNGUnit unit, int numRepeated=1)
| open a row with given height ( if h < 0.0, set min-row-height = -h ) More...
void | closeSheetRow ()
| closes this row More...
void | openSheetCell (STOFFCell const &cell, STOFFCellContent const &content, int numRepeated=1)
| open a cell More...
void | closeSheetCell ()
| close a cell More...
void | insertChart (STOFFFrameStyle const &frame, STOFFChart &chart, STOFFGraphicStyle const &style=STOFFGraphicStyle())
| adds a chart in given position More...
void | insertChar (uint8_t character) final
| adds a basic character, .. More...
void | insertUnicode (uint32_t character) final
| adds an unicode character. More...
void | insertUnicodeString (librevenge::RVNGString const &str) final
| adds a unicode string More...
void | insertTab () final
| adds a tab More...
void | insertEOL (bool softBreak=false) final
| adds an end of line ( by default an hard one) More...
void | setFont (STOFFFont const &font) final
| sets the font More...
STOFFFont const & | getFont () const final
| returns the actual font More...
bool | isParagraphOpened () const final
| returns true if a paragraph or a list is opened More...
void | setParagraph (STOFFParagraph const &paragraph) final
| sets the paragraph More...
STOFFParagraph const & | getParagraph () const final
| returns the actual paragraph More...
void | defineStyle (STOFFFont const &style) final
| defines a font styles More...
bool | isFontStyleDefined (librevenge::RVNGString const &name) const final
| check if a font style with a display name is already defined More...
void | defineStyle (STOFFGraphicStyle const &style) final
| defines a graphic styles More...
bool | isGraphicStyleDefined (librevenge::RVNGString const &name) const final
| check if a graphic style with a display name is already defined More...
void | defineStyle (STOFFParagraph const &style) final
| defines a paragraph styles More...
bool | isParagraphStyleDefined (librevenge::RVNGString const &name) const final
| check if a paragraph style with a display name is already defined More...
void | insertField (STOFFField const &field) final
| adds a field type More...
void | openLink (STOFFLink const &link) final
| open a link More...
void | closeLink () final
| close a link More...
void | insertNote (STOFFNote const &note, STOFFSubDocumentPtr &subDocument) final
| insert a note More...
void | insertComment (STOFFSubDocumentPtr &subDocument, librevenge::RVNGString const &creator="", librevenge::RVNGString const &date="") final
| adds comment More...
void | insertPicture (STOFFFrameStyle const &frame, STOFFEmbeddedObject const &picture, STOFFGraphicStyle const &style=STOFFGraphicStyle()) final
| adds a picture with potential various representationin given position More...
void | insertEquation (STOFFFrameStyle const &frame, librevenge::RVNGString const &equation, STOFFGraphicStyle const &style=STOFFGraphicStyle()) final
| adds a equation given a position More...
void | insertShape (STOFFFrameStyle const &frame, STOFFGraphicShape const &shape, STOFFGraphicStyle const &style) final
| adds a shape picture in given position More...
void | insertTextBox (STOFFFrameStyle const &frame, STOFFSubDocumentPtr subDocument, STOFFGraphicStyle const &frameStyle=STOFFGraphicStyle()) final
| adds a textbox in given position More...
void | openTable (STOFFTable const &table) final
| open a table More...
void | closeTable () final
| closes this table More...
void | openTableRow (float h, librevenge::RVNGUnit unit, bool headerRow=false) final
| open a row with given height ( if h < 0.0, set min-row-height = -h ) More...
void | closeTableRow () final
| closes this row More...
void | openTableCell (STOFFCell const &cell) final
| open a cell More...
void | closeTableCell () final
| close a cell More...
void | addCoveredTableCell (STOFFVec2i const &pos) final
| add covered cell More...
void | addEmptyTableCell (STOFFVec2i const &pos, STOFFVec2i span=STOFFVec2i(1, 1)) final
| add empty cell More...
bool | canOpenSectionAddBreak () const final
| returns true if we can add open a section, add page break, ... More...
bool | isSectionOpened () const final
| returns true if a section is opened More...
STOFFSection const & | getSection () const final
| returns the actual section More...
bool | openSection (STOFFSection const &section) final
| open a section if possible More...
bool | closeSection () final
| close a section More...
void | insertBreak (BreakType breakType) final
| inserts a break type: ColumBreak, PageBreak, .. More...
Public Member Functions inherited from STOFFListener
virtual | ~STOFFListener ()
| destructor More...
virtual Type | getType () const =0
| returns the listener type More...
virtual bool | canWriteText () const =0
| returns true if we can add text data More...
STOFFListManagerPtr | getListManager () const
| return the list manager More...
virtual void | setDocumentLanguage (std::string locale)=0
| sets the documents language More...
virtual void | setDocumentMetaData (const librevenge::RVNGPropertyList &list)=0
| sets the document meta data More...
virtual void | startDocument ()=0
| starts the document More...
virtual bool | isDocumentStarted () const =0
| returns true if a document is opened More...
virtual void | endDocument (bool sendDelayedSubDoc=true)=0
| ends the document More...
virtual bool | isPageSpanOpened () const =0
| returns true if a page is opened More...
virtual STOFFPageSpan const & | getPageSpan ()=0
| returns the current page span More...
virtual bool | openHeader (librevenge::RVNGPropertyList const &extras)=0
| open a header (interaction with STOFFPageSpan which fills the parameters for openHeader) More...
virtual bool | openFooter (librevenge::RVNGPropertyList const &extras)=0
| open a footer (interaction with STOFFPageSpan which fills the parameters for openFooter) More...
virtual bool | closeHeader ()=0
| close a header More...
virtual bool | closeFooter ()=0
| close a footer More...
virtual bool | insertHeaderRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which)=0
| insert a header More...
virtual bool | insertFooterRegion (STOFFSubDocumentPtr subDocument, librevenge::RVNGString const &which)=0
| insert a footer More...
virtual bool | isHeaderFooterOpened () const =0
| returns true if the header/footer is open More...
virtual void | insertChar (uint8_t character)=0
| adds a basic character, .. More...
virtual void | insertUnicode (uint32_t character)=0
| adds an unicode character. More...
void | insertUnicodeList (std::vector< uint32_t > const &list)
| try to insert a list of unicode character More...
virtual void | insertUnicodeString (librevenge::RVNGString const &str)=0
| adds a unicode string More...
virtual void | insertTab ()=0
| adds a tab More...
virtual void | insertEOL (bool softBreak=false)=0
| adds an end of line ( by default an hard one) More...
virtual void | setFont (STOFFFont const &font)=0
| sets the font More...
virtual STOFFFont const & | getFont () const =0
| returns the actual font More...
virtual bool | isParagraphOpened () const =0
| returns true if a paragraph or a list is opened More...
virtual void | setParagraph (STOFFParagraph const &paragraph)=0
| sets the paragraph More...
virtual STOFFParagraph const & | getParagraph () const =0
| returns the actual paragraph More...
virtual void | defineStyle (STOFFFont const &style)=0
| defines a font styles More...
virtual bool | isFontStyleDefined (librevenge::RVNGString const &name) const =0
| check if a font style with a display name is already defined More...
virtual void | defineStyle (STOFFGraphicStyle const &style)=0
| defines a graphic styles More...
virtual bool | isGraphicStyleDefined (librevenge::RVNGString const &name) const =0
| check if a graphic style with a display name is already defined More...
virtual void | defineStyle (STOFFParagraph const &style)=0
| defines a paragraph styles More...
virtual bool | isParagraphStyleDefined (librevenge::RVNGString const &name) const =0
| check if a paragraph style with a display name is already defined More...
virtual void | insertField (STOFFField const &field)=0
| adds a field type More...
virtual void | openLink (STOFFLink const &link)=0
| open a link More...
virtual void | closeLink ()=0
| close a link More...
virtual void | openTable (STOFFTable const &table)=0
| open a table More...
virtual void | closeTable ()=0
| closes this table More...
virtual void | openTableRow (float h, librevenge::RVNGUnit unit, bool headerRow=false)=0
| open a row with given height ( if h < 0.0, set min-row-height = -h ) More...
virtual void | closeTableRow ()=0
| closes this row More...
virtual void | openTableCell (STOFFCell const &cell)=0
| open a cell More...
virtual void | closeTableCell ()=0
| close a cell More...
virtual void | addCoveredTableCell (STOFFVec2i const &pos)=0
| add covered cell More...
virtual void | addEmptyTableCell (STOFFVec2i const &pos, STOFFVec2i span=STOFFVec2i(1, 1))=0
| add empty cell More...
virtual bool | canOpenSectionAddBreak () const =0
| returns true if we can add open a section, add page break, ... More...
virtual bool | isSectionOpened () const =0
| returns true if a section is opened More...
virtual STOFFSection const & | getSection () const =0
| returns the actual section More...
virtual bool | openSection (STOFFSection const &section)=0
| open a section if possible More...
virtual bool | closeSection ()=0
| close a section More...
virtual void | insertBreak (BreakType breakType)=0
| inserts a break type: ColumBreak, PageBreak, .. More...
virtual void | insertNote (STOFFNote const &note, STOFFSubDocumentPtr &subDocument)=0
| insert a note More...
virtual void | insertComment (STOFFSubDocumentPtr &subDocument, librevenge::RVNGString const &creator="", librevenge::RVNGString const &date="")=0
| adds comment More...
virtual void | insertEquation (STOFFFrameStyle const &frame, librevenge::RVNGString const &equation, STOFFGraphicStyle const &style=STOFFGraphicStyle())=0
| adds a equation given a position More...
virtual void | insertPicture (STOFFFrameStyle const &frame, STOFFEmbeddedObject const &picture, STOFFGraphicStyle const &style=STOFFGraphicStyle())=0
| adds a picture with various representationin given position. More...
virtual void | insertShape (STOFFFrameStyle const &frame, STOFFGraphicShape const &shape, STOFFGraphicStyle const &style)=0
| adds a shape picture in given position More...
virtual void | insertTextBox (STOFFFrameStyle const &frame, STOFFSubDocumentPtr subDocument, STOFFGraphicStyle const &frameStyle=STOFFGraphicStyle())=0
| adds a textbox in given position More...
virtual bool | openFrame (STOFFFrameStyle const &frame, STOFFGraphicStyle const &style=STOFFGraphicStyle())=0
| low level: tries to open a frame More...
virtual void | closeFrame ()=0
| low level: tries to close the last opened frame More...
virtual bool | openGroup (STOFFFrameStyle const &frame)=0
| low level: tries to open a group More...
virtual void | closeGroup ()=0
| low level: tries to close the last opened group More...
virtual void | handleSubDocument (STOFFSubDocumentPtr subDocument, libstoff::SubDocumentType subDocumentType)=0
| low level: function called to add a subdocument More...
virtual bool | isSubDocumentOpened (libstoff::SubDocumentType &subdocType) const =0
| returns true if a subdocument is open More...

## Protected Member Functions
void | _openPageSpan (bool sendHeaderFooters=true)
| does open a new page (low level) More...
void | _closePageSpan ()
| does close a page (low level) More...
void | _startSubDocument ()
void | _endSubDocument ()
void | _handleFrameParameters (librevenge::RVNGPropertyList &propList, STOFFFrameStyle const &frame)
void | _openParagraph ()
void | _closeParagraph ()
void | _resetParagraphState (const bool isListElement=false)
void | _openListElement ()
| open a list level More...
void | _closeListElement ()
| close a list level More...
void | _changeList ()
| update the list so that it corresponds to the actual level More...
int | _getListId () const
| low level: find a list id which corresponds to actual list and a change of level. More...
void | _openSpan ()
void | _closeSpan ()
void | _flushText ()
void | _flushDeferredTabs ()
std::shared_ptr< STOFFSpreadsheetListenerInternal::State > | _pushParsingState ()
| creates a new parsing state (copy of the actual state) More...
void | _popParsingState ()
| resets the previous parsing state More...
Protected Member Functions inherited from STOFFListener
| STOFFListener (STOFFListManagerPtr &listManager)
| constructor More...

## Protected Attributes
std::shared_ptr< STOFFSpreadsheetListenerInternal::DocumentState > | m_ds
| the main parse state More...
std::shared_ptr< STOFFSpreadsheetListenerInternal::State > | m_ps
| the actual local parse state More...
std::vector< std::shared_ptr< STOFFSpreadsheetListenerInternal::State > > | m_psStack
| stack of local state More...
librevenge::RVNGSpreadsheetInterface * | m_documentInterface
| the document interface More...
Protected Attributes inherited from STOFFListener
STOFFListManagerPtr | m_listManager
| the list manager More...

## Private Member Functions
| STOFFSpreadsheetListener (const STOFFSpreadsheetListener &)
| copy constructor (unimplemented) More...
STOFFSpreadsheetListener & | operator= (const STOFFSpreadsheetListener &)
| operator= (unimplemented) More...

## Additional Inherited Members
Public Types inherited from STOFFListener
enum | Type { Graphic , Presentation , Spreadsheet , Text }
| the listener type More...
enum | BreakType { PageBreak =0 , SoftPageBreak , ColumnBreak }
| the different break type More...

## Detailed Description

This class contents the main functions needed to create a spreadsheet processing Document.

## Constructor & Destructor Documentation

## ◆ STOFFSpreadsheetListener() [1/2]

STOFFSpreadsheetListener::STOFFSpreadsheetListener | ( | STOFFListManagerPtr & | listManager,
|  | std::vector< STOFFPageSpan > const & | pageList,
|  | librevenge::RVNGSpreadsheetInterface * | documentInterface
| ) |  |

constructor

## ◆ ~STOFFSpreadsheetListener()

STOFFSpreadsheetListener::~STOFFSpreadsheetListener | ( |  | ) |
| final

destructor

## ◆ STOFFSpreadsheetListener() [2/2]

STOFFSpreadsheetListener::STOFFSpreadsheetListener | ( | const STOFFSpreadsheetListener & |  | ) |
| private

copy constructor (unimplemented)

## Member Function Documentation

## ◆ _changeList()

void STOFFSpreadsheetListener::_changeList | ( |  | ) |
| protected

update the list so that it corresponds to the actual level

Referenced by _endSubDocument(), _openSpan(), closeTableCell(), endDocument(), and insertNote().

## ◆ _closeListElement()

void STOFFSpreadsheetListener::_closeListElement | ( |  | ) |
| protected

close a list level

Referenced by _closeParagraph().

## ◆ _closePageSpan()

void STOFFSpreadsheetListener::_closePageSpan | ( |  | ) |
| protected

does close a page (low level)

Referenced by endDocument(), and insertBreak().

## ◆ _closeParagraph()

void STOFFSpreadsheetListener::_closeParagraph | ( |  | ) |
| protected

Referenced by _changeList(), _endSubDocument(), closeSheetCell(), closeTableCell(), endDocument(), insertBreak(), insertComment(), insertEOL(), insertNote(), openSheet(), and openTable().

## ◆ _closeSpan()

void STOFFSpreadsheetListener::_closeSpan | ( |  | ) |
| protected

Referenced by _closeListElement(), _closeParagraph(), _endSubDocument(), closeLink(), insertComment(), insertNote(), and setFont().

## ◆ _endSubDocument()

void STOFFSpreadsheetListener::_endSubDocument | ( |  | ) |
| protected

Referenced by closeSheet(), closeTable(), handleSubDocument(), and insertChart().

## ◆ _flushDeferredTabs()

void STOFFSpreadsheetListener::_flushDeferredTabs | ( |  | ) |
| protected

Referenced by insertChar(), insertEOL(), insertField(), insertTab(), insertUnicode(), insertUnicodeString(), and openLink().

## ◆ _flushText()

void STOFFSpreadsheetListener::_flushText | ( |  | ) |
| protected

Referenced by _closeSpan(), insertComment(), insertEOL(), insertField(), insertNote(), insertShape(), insertTab(), openFrame(), and openLink().

## ◆ _getListId()

int STOFFSpreadsheetListener::_getListId | ( |  | ) | const
| protected

low level: find a list id which corresponds to actual list and a change of level.

Note
  called when the list id is not set

Referenced by _changeList().

## ◆ _handleFrameParameters()

void STOFFSpreadsheetListener::_handleFrameParameters | ( | librevenge::RVNGPropertyList & | propList,
|  | STOFFFrameStyle const & | frame
| ) |  |
| protected

Referenced by openFrame().

## ◆ _openListElement()

void STOFFSpreadsheetListener::_openListElement | ( |  | ) |
| protected

open a list level

Referenced by _openSpan().

## ◆ _openPageSpan()

void STOFFSpreadsheetListener::_openPageSpan | ( | bool | sendHeaderFooters = `true` | ) |
| protected

does open a new page (low level)

Referenced by endDocument(), getPageSpan(), and openSheet().

## ◆ _openParagraph()

void STOFFSpreadsheetListener::_openParagraph | ( |  | ) |
| protected

Referenced by _openSpan(), insertComment(), insertNote(), insertShape(), and openFrame().

## ◆ _openSpan()

void STOFFSpreadsheetListener::_openSpan | ( |  | ) |
| protected

Referenced by _flushDeferredTabs(), endDocument(), handleSubDocument(), insertBreak(), insertChar(), insertEOL(), insertField(), insertShape(), insertUnicode(), insertUnicodeString(), openFrame(), and openLink().

## ◆ _popParsingState()

void STOFFSpreadsheetListener::_popParsingState | ( |  | ) |
| protected

resets the previous parsing state

Referenced by closeFooter(), closeHeader(), closeLink(), closeSheet(), closeSheetCell(), closeTable(), handleSubDocument(), and insertChart().

## ◆ _pushParsingState()

std::shared_ptr< STOFFSpreadsheetListenerInternal::State > STOFFSpreadsheetListener::_pushParsingState | ( |  | ) |
| protected

creates a new parsing state (copy of the actual state)

Returns
  the old one

Referenced by handleSubDocument(), insertChart(), openFooter(), openHeader(), openLink(), openSheet(), openSheetCell(), and openTable().

## ◆ _resetParagraphState()

void STOFFSpreadsheetListener::_resetParagraphState | ( | const bool | isListElement = `false` | ) |
| protected

Referenced by _openListElement(), and _openParagraph().

## ◆ _startSubDocument()

void STOFFSpreadsheetListener::_startSubDocument | ( |  | ) |
| protected

Referenced by handleSubDocument(), insertChart(), openSheet(), and openTable().

## ◆ addCoveredTableCell()

void STOFFSpreadsheetListener::addCoveredTableCell | ( | STOFFVec2i const & | pos | ) |
| finalvirtual

add covered cell

Implements STOFFListener.

## ◆ addEmptyTableCell()

void STOFFSpreadsheetListener::addEmptyTableCell | ( | STOFFVec2i const & | pos,
|  | STOFFVec2i | span = `STOFFVec2i(1,1)`
| ) |  |
| finalvirtual

add empty cell

Implements STOFFListener.

## ◆ canOpenSectionAddBreak()

bool STOFFSpreadsheetListener::canOpenSectionAddBreak | ( |  | ) | const
| inlinefinalvirtual

returns true if we can add open a section, add page break, ...

Implements STOFFListener.

## ◆ canWriteText()

bool STOFFSpreadsheetListener::canWriteText | ( |  | ) | const
| finalvirtual

returns true if we can add text data

Implements STOFFListener.

Referenced by insertComment(), and insertNote().

## ◆ closeFooter()

bool STOFFSpreadsheetListener::closeFooter | ( |  | ) |
| finalvirtual

close a footer

Implements STOFFListener.

## ◆ closeFrame()

void STOFFSpreadsheetListener::closeFrame | ( |  | ) |
| finalvirtual

tries to close a frame

Implements STOFFListener.

Referenced by insertChart(), insertEquation(), insertPicture(), and insertTextBox().

## ◆ closeGroup()

void STOFFSpreadsheetListener::closeGroup | ( |  | ) |
| finalvirtual

close a group (not implemented)

Implements STOFFListener.

## ◆ closeHeader()

bool STOFFSpreadsheetListener::closeHeader | ( |  | ) |
| finalvirtual

close a header

Implements STOFFListener.

## ◆ closeLink()

void STOFFSpreadsheetListener::closeLink | ( |  | ) |
| finalvirtual

close a link

Implements STOFFListener.

## ◆ closeSection()

bool STOFFSpreadsheetListener::closeSection | ( |  | ) |
| finalvirtual

close a section

Implements STOFFListener.

## ◆ closeSheet()

void STOFFSpreadsheetListener::closeSheet | ( |  | ) |

closes this sheet

Referenced by endDocument().

## ◆ closeSheetCell()

void STOFFSpreadsheetListener::closeSheetCell | ( |  | ) |

close a cell

Referenced by openSheetCell().

## ◆ closeSheetRow()

void STOFFSpreadsheetListener::closeSheetRow | ( |  | ) |

closes this row

## ◆ closeTable()

void STOFFSpreadsheetListener::closeTable | ( |  | ) |
| finalvirtual

closes this table

Implements STOFFListener.

Referenced by _endSubDocument(), and endDocument().

## ◆ closeTableCell()

void STOFFSpreadsheetListener::closeTableCell | ( |  | ) |
| finalvirtual

close a cell

Implements STOFFListener.

Referenced by addCoveredTableCell(), addEmptyTableCell(), and openTableCell().

## ◆ closeTableRow()

void STOFFSpreadsheetListener::closeTableRow | ( |  | ) |
| finalvirtual

closes this row

Implements STOFFListener.

## ◆ defineStyle() [1/3]

void STOFFSpreadsheetListener::defineStyle | ( | STOFFFont const & | style | ) |
| finalvirtual

defines a font styles

Implements STOFFListener.

## ◆ defineStyle() [2/3]

void STOFFSpreadsheetListener::defineStyle | ( | STOFFGraphicStyle const & | style | ) |
| finalvirtual

defines a graphic styles

Implements STOFFListener.

## ◆ defineStyle() [3/3]

void STOFFSpreadsheetListener::defineStyle | ( | STOFFParagraph const & | style | ) |
| finalvirtual

defines a paragraph styles

Implements STOFFListener.

## ◆ endDocument()

void STOFFSpreadsheetListener::endDocument | ( | bool | sendDelayedSubDoc = `true` | ) |
| finalvirtual

ends the document

Implements STOFFListener.

## ◆ getFont()

STOFFFont const & STOFFSpreadsheetListener::getFont | ( |  | ) | const
| finalvirtual

returns the actual font

Implements STOFFListener.

## ◆ getPageSpan()

STOFFPageSpan const & STOFFSpreadsheetListener::getPageSpan | ( |  | ) |
| finalvirtual

returns the current page span

Note
  this forces the opening of a new page if no page is opened.

Implements STOFFListener.

## ◆ getParagraph()

STOFFParagraph const & STOFFSpreadsheetListener::getParagraph | ( |  | ) | const
| finalvirtual

returns the actual paragraph

Implements STOFFListener.

## ◆ getSection()

STOFFSection const & STOFFSpreadsheetListener::getSection | ( |  | ) | const
| finalvirtual

returns the actual section

Implements STOFFListener.

## ◆ getType()

Type STOFFSpreadsheetListener::getType | ( |  | ) | const
| inlinefinalvirtual

returns the listener type

Implements STOFFListener.

## ◆ handleSubDocument()

void STOFFSpreadsheetListener::handleSubDocument | ( | STOFFSubDocumentPtr | subDocument,
|  | libstoff::SubDocumentType | subDocumentType
| ) |  |
| finalvirtual

function called to add a subdocument

Implements STOFFListener.

Referenced by insertComment(), insertFooterRegion(), insertHeaderRegion(), insertNote(), and insertTextBox().

## ◆ insertBreak()

void STOFFSpreadsheetListener::insertBreak | ( | STOFFSpreadsheetListener::BreakType | type | ) |
| finalvirtual

inserts a break type: ColumBreak, PageBreak, ..

Implements STOFFListener.

## ◆ insertChar()

void STOFFSpreadsheetListener::insertChar | ( | uint8_t | character | ) |
| finalvirtual

adds a basic character, ..

Implements STOFFListener.

## ◆ insertChart()

void STOFFSpreadsheetListener::insertChart | ( | STOFFFrameStyle const & | frame,
|  | STOFFChart & | chart,
|  | STOFFGraphicStyle const & | style = `STOFFGraphicStyle()`
| ) |  |

adds a chart in given position

## ◆ insertComment()

void STOFFSpreadsheetListener::insertComment | ( | STOFFSubDocumentPtr & | subDocument,
|  | librevenge::RVNGString const & | creator = `""`,
|  | librevenge::RVNGString const & | date = `""`
| ) |  |
| finalvirtual

adds comment

Implements STOFFListener.

## ◆ insertEOL()

void STOFFSpreadsheetListener::insertEOL | ( | bool | softBreak = `false` | ) |
| finalvirtual

adds an end of line ( by default an hard one)

Implements STOFFListener.

## ◆ insertEquation()

void STOFFSpreadsheetListener::insertEquation | ( | STOFFFrameStyle const & | frame,
|  | librevenge::RVNGString const & | equation,
|  | STOFFGraphicStyle const & | style = `STOFFGraphicStyle()`
| ) |  |
| finalvirtual

adds a equation given a position

Implements STOFFListener.

## ◆ insertField()

void STOFFSpreadsheetListener::insertField | ( | STOFFField const & | field | ) |
| finalvirtual

adds a field type

Implements STOFFListener.

## ◆ insertFooterRegion()

bool STOFFSpreadsheetListener::insertFooterRegion | ( | STOFFSubDocumentPtr | subDocument,
|  | librevenge::RVNGString const & | which
| ) |  |
| finalvirtual

insert a footer

Implements STOFFListener.

## ◆ insertHeaderRegion()

bool STOFFSpreadsheetListener::insertHeaderRegion | ( | STOFFSubDocumentPtr | subDocument,
|  | librevenge::RVNGString const & | which
| ) |  |
| finalvirtual

insert a header

Implements STOFFListener.

## ◆ insertNote()

void STOFFSpreadsheetListener::insertNote | ( | STOFFNote const & | note,
|  | STOFFSubDocumentPtr & | subDocument
| ) |  |
| finalvirtual

insert a note

Must not happen excepted in corrupted document, so we do the minimum. Note that we have no choice, either we begin by closing the paragraph, ... or we reprogram handleSubDocument.

Implements STOFFListener.

## ◆ insertPicture()

void STOFFSpreadsheetListener::insertPicture | ( | STOFFFrameStyle const & | frame,
|  | STOFFEmbeddedObject const & | picture,
|  | STOFFGraphicStyle const & | style = `STOFFGraphicStyle()`
| ) |  |
| finalvirtual

adds a picture with potential various representationin given position

Implements STOFFListener.

## ◆ insertShape()

void STOFFSpreadsheetListener::insertShape | ( | STOFFFrameStyle const & | frame,
|  | STOFFGraphicShape const & | shape,
|  | STOFFGraphicStyle const & | style
| ) |  |
| finalvirtual

adds a shape picture in given position

Implements STOFFListener.

## ◆ insertTab()

void STOFFSpreadsheetListener::insertTab | ( |  | ) |
| finalvirtual

adds a tab

Implements STOFFListener.

## ◆ insertTextBox()

void STOFFSpreadsheetListener::insertTextBox | ( | STOFFFrameStyle const & | frame,
|  | STOFFSubDocumentPtr | subDocument,
|  | STOFFGraphicStyle const & | frameStyle = `STOFFGraphicStyle()`
| ) |  |
| finalvirtual

adds a textbox in given position

Implements STOFFListener.

## ◆ insertUnicode()

void STOFFSpreadsheetListener::insertUnicode | ( | uint32_t | character | ) |
| finalvirtual

adds an unicode character.

By convention if character=0xfffd(undef), no character is added

Implements STOFFListener.

Referenced by insertChar().

## ◆ insertUnicodeString()

void STOFFSpreadsheetListener::insertUnicodeString | ( | librevenge::RVNGString const & | str | ) |
| finalvirtual

adds a unicode string

Implements STOFFListener.

## ◆ isDocumentStarted()

bool STOFFSpreadsheetListener::isDocumentStarted | ( |  | ) | const
| finalvirtual

returns true if a document is opened

Implements STOFFListener.

## ◆ isFontStyleDefined()

bool STOFFSpreadsheetListener::isFontStyleDefined | ( | librevenge::RVNGString const & | name | ) | const
| finalvirtual

check if a font style with a display name is already defined

Implements STOFFListener.

## ◆ isGraphicStyleDefined()

bool STOFFSpreadsheetListener::isGraphicStyleDefined | ( | librevenge::RVNGString const & | name | ) | const
| finalvirtual

check if a graphic style with a display name is already defined

Implements STOFFListener.

## ◆ isHeaderFooterOpened()

bool STOFFSpreadsheetListener::isHeaderFooterOpened | ( |  | ) | const
| finalvirtual

returns true if the header/footer is open

Implements STOFFListener.

## ◆ isPageSpanOpened()

bool STOFFSpreadsheetListener::isPageSpanOpened | ( |  | ) | const
| finalvirtual

returns true if a page is opened

Implements STOFFListener.

## ◆ isParagraphOpened()

bool STOFFSpreadsheetListener::isParagraphOpened | ( |  | ) | const
| finalvirtual

returns true if a paragraph or a list is opened

Implements STOFFListener.

## ◆ isParagraphStyleDefined()

bool STOFFSpreadsheetListener::isParagraphStyleDefined | ( | librevenge::RVNGString const & | name | ) | const
| finalvirtual

check if a paragraph style with a display name is already defined

Implements STOFFListener.

## ◆ isSectionOpened()

bool STOFFSpreadsheetListener::isSectionOpened | ( |  | ) | const
| inlinefinalvirtual

returns true if a section is opened

Implements STOFFListener.

## ◆ isSubDocumentOpened()

bool STOFFSpreadsheetListener::isSubDocumentOpened | ( | libstoff::SubDocumentType & | subdocType | ) | const
| finalvirtual

returns try if a subdocument is open

Implements STOFFListener.

## ◆ openFooter()

bool STOFFSpreadsheetListener::openFooter | ( | librevenge::RVNGPropertyList const & | extras | ) |
| finalvirtual

open a footer (interaction with STOFFPageSpan which fills the parameters for openFooter)

Implements STOFFListener.

## ◆ openFrame()

bool STOFFSpreadsheetListener::openFrame | ( | STOFFFrameStyle const & | frame,
|  | STOFFGraphicStyle const & | style = `STOFFGraphicStyle()`
| ) |  |
| finalvirtual

tries to open a frame

Implements STOFFListener.

Referenced by insertChart(), insertEquation(), insertPicture(), and insertTextBox().

## ◆ openGroup()

bool STOFFSpreadsheetListener::openGroup | ( | STOFFFrameStyle const & | frame | ) |
| finalvirtual

open a group (not implemented)

Implements STOFFListener.

## ◆ openHeader()

bool STOFFSpreadsheetListener::openHeader | ( | librevenge::RVNGPropertyList const & | extras | ) |
| finalvirtual

open a header (interaction with STOFFPageSpan which fills the parameters for openHeader)

Implements STOFFListener.

## ◆ openLink()

void STOFFSpreadsheetListener::openLink | ( | STOFFLink const & | link | ) |
| finalvirtual

open a link

Implements STOFFListener.

## ◆ openSection()

bool STOFFSpreadsheetListener::openSection | ( | STOFFSection const & | section | ) |
| finalvirtual

open a section if possible

Implements STOFFListener.

## ◆ openSheet()

void STOFFSpreadsheetListener::openSheet | ( | std::vector< float > const & | colWidth,
|  | librevenge::RVNGUnit | unit,
|  | std::vector< int > const & | repeatColWidthNumber = `std::vector<int>()`,
|  | librevenge::RVNGString const & | name = `""`
| ) |  |

open a sheet

## ◆ openSheetCell()

void STOFFSpreadsheetListener::openSheetCell | ( | STOFFCell const & | cell,
|  | STOFFCellContent const & | content,
|  | int | numRepeated = `1`
| ) |  |

open a cell

## ◆ openSheetRow()

void STOFFSpreadsheetListener::openSheetRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | int | numRepeated = `1`
| ) |  |

open a row with given height ( if h < 0.0, set min-row-height = -h )

## ◆ openTable()

void STOFFSpreadsheetListener::openTable | ( | STOFFTable const & | table | ) |
| finalvirtual

open a table

Implements STOFFListener.

## ◆ openTableCell()

void STOFFSpreadsheetListener::openTableCell | ( | STOFFCell const & | cell | ) |
| finalvirtual

open a cell

Implements STOFFListener.

## ◆ openTableRow()

void STOFFSpreadsheetListener::openTableRow | ( | float | h,
|  | librevenge::RVNGUnit | unit,
|  | bool | headerRow = `false`
| ) |  |
| finalvirtual

open a row with given height ( if h < 0.0, set min-row-height = -h )

Implements STOFFListener.

## ◆ operator=()

STOFFSpreadsheetListener & STOFFSpreadsheetListener::operator= | ( | const STOFFSpreadsheetListener & |  | ) |
| private

operator= (unimplemented)

## ◆ setDocumentLanguage()

void STOFFSpreadsheetListener::setDocumentLanguage | ( | std::string | locale | ) |
| finalvirtual

sets the document language

Implements STOFFListener.

## ◆ setDocumentMetaData()

void STOFFSpreadsheetListener::setDocumentMetaData | ( | const librevenge::RVNGPropertyList & | list | ) |
| finalvirtual

sets the document meta data

Implements STOFFListener.

## ◆ setFont()

void STOFFSpreadsheetListener::setFont | ( | STOFFFont const & | font | ) |
| finalvirtual

sets the font

Implements STOFFListener.

## ◆ setParagraph()

void STOFFSpreadsheetListener::setParagraph | ( | STOFFParagraph const & | paragraph | ) |
| finalvirtual

sets the paragraph

Implements STOFFListener.

## ◆ startDocument()

void STOFFSpreadsheetListener::startDocument | ( |  | ) |
| finalvirtual

starts the document

Implements STOFFListener.

Referenced by _openPageSpan().

## Member Data Documentation

## ◆ m_documentInterface

librevenge::RVNGSpreadsheetInterface* STOFFSpreadsheetListener::m_documentInterface
| protected

the document interface

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _flushDeferredTabs(), _flushText(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), addCoveredTableCell(), addEmptyTableCell(), closeFooter(), closeFrame(), closeHeader(), closeLink(), closeSheet(), closeSheetCell(), closeSheetRow(), closeTable(), closeTableCell(), closeTableRow(), defineStyle(), endDocument(), insertChart(), insertComment(), insertEOL(), insertEquation(), insertField(), insertFooterRegion(), insertHeaderRegion(), insertNote(), insertPicture(), insertShape(), insertTextBox(), openFooter(), openFrame(), openHeader(), openLink(), openSheet(), openSheetCell(), openSheetRow(), openTable(), openTableCell(), openTableRow(), and startDocument().

## ◆ m_ds

std::shared_ptr<STOFFSpreadsheetListenerInternal::DocumentState> STOFFSpreadsheetListener::m_ds
| protected

the main parse state

Referenced by _changeList(), _openPageSpan(), _startSubDocument(), closeSheet(), closeSheetRow(), defineStyle(), endDocument(), getPageSpan(), getSection(), handleSubDocument(), insertBreak(), insertChart(), insertEquation(), insertNote(), insertPicture(), insertShape(), insertTextBox(), isDocumentStarted(), isFontStyleDefined(), isGraphicStyleDefined(), isParagraphStyleDefined(), openFrame(), openSheet(), openSheetCell(), openSheetRow(), setDocumentLanguage(), setDocumentMetaData(), and startDocument().

## ◆ m_ps

std::shared_ptr<STOFFSpreadsheetListenerInternal::State> STOFFSpreadsheetListener::m_ps
| protected

the actual local parse state

Referenced by _changeList(), _closeListElement(), _closePageSpan(), _closeParagraph(), _closeSpan(), _endSubDocument(), _flushDeferredTabs(), _flushText(), _getListId(), _openListElement(), _openPageSpan(), _openParagraph(), _openSpan(), _popParsingState(), _pushParsingState(), _resetParagraphState(), _startSubDocument(), addCoveredTableCell(), addEmptyTableCell(), canWriteText(), closeFooter(), closeFrame(), closeHeader(), closeLink(), closeSheetCell(), closeTable(), closeTableCell(), closeTableRow(), endDocument(), getFont(), getPageSpan(), getParagraph(), handleSubDocument(), insertBreak(), insertChar(), insertChart(), insertComment(), insertEOL(), insertField(), insertFooterRegion(), insertHeaderRegion(), insertNote(), insertShape(), insertTab(), insertUnicode(), insertUnicodeString(), isHeaderFooterOpened(), isPageSpanOpened(), isParagraphOpened(), isSubDocumentOpened(), openFooter(), openFrame(), openHeader(), openLink(), openSheet(), openSheetCell(), openTable(), openTableCell(), openTableRow(), setFont(), and setParagraph().

## ◆ m_psStack

std::vector<std::shared_ptr<STOFFSpreadsheetListenerInternal::State> > STOFFSpreadsheetListener::m_psStack
| protected

stack of local state

Referenced by _popParsingState(), and _pushParsingState().

The documentation for this class was generated from the following files:

- STOFFSpreadsheetListener.hxx
- STOFFSpreadsheetListener.cxx